#[doc = "Register `D00` reader"]
pub struct R(crate::R<D00_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<D00_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<D00_SPEC>> for R {
    fn from(reader: crate::R<D00_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `D00` writer"]
pub struct W(crate::W<D00_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<D00_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<D00_SPEC>> for W {
    fn from(writer: crate::W<D00_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `D0` reader - Data 0"]
pub struct D0_R(crate::FieldReader<u8, u8>);
impl D0_R {
    pub(crate) fn new(bits: u8) -> Self {
        D0_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for D0_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `D0` writer - Data 0"]
pub struct D0_W<'a> {
    w: &'a mut W,
}
impl<'a> D0_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u8 & 0xff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Data 0"]
    #[inline(always)]
    pub fn d0(&self) -> D0_R {
        D0_R::new((self.bits & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Data 0"]
    #[inline(always)]
    pub fn d0(&mut self) -> D0_W {
        D0_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Data 0\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [d00](index.html) module"]
pub struct D00_SPEC;
impl crate::RegisterSpec for D00_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [d00::R](R) reader structure"]
impl crate::Readable for D00_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [d00::W](W) writer structure"]
impl crate::Writable for D00_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets D00 to value 0"]
impl crate::Resettable for D00_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
